PatternMatcher (Jakarta-ORO 2.0.8 API)
Date: 2018-05-07

org.apache.oro.text.regex

## Interface PatternMatcher

- All Known Implementing Classes:
    AwkMatcher, Perl5Matcher

      public interface PatternMatcher

  The PatternMatcher interface defines the operations a regular expression matcher must implement. However, the types of the Pattern implementations recognized by a matcher are not restricted. Typically PatternMatcher instances will only recognize a specific type of Pattern. For example, the Perl5Matcher only recognizes Perl5Pattern instances. However, none of the PatternMatcher methods are required to throw an exception in case of the use of an invalid pattern. This is done for efficiency reasons, although usually a CastClassException will be thrown by the Java runtime system if you use the wrong Pattern implementation. It is the responsibility of the programmer to make sure he uses the correct Pattern instance with a given PatternMatcher instance. The current version of this package only contains the Perl5 suite of pattern matching classes, but future ones for other regular expression grammars may be added and users may also create their own implementations of the provided interfaces. Therefore the programmer should be careful not to mismatch classes.
  Since:
    1.0
  Version:
    2.0.8
  See Also:
    `Pattern`, `PatternCompiler`, `MatchResult`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `contains(char[] input, Pattern pattern)` Determines if a string (represented as a char[]) contains a pattern.
    `boolean` | `contains(PatternMatcherInput input, Pattern pattern)` Determines if the contents of a PatternMatcherInput, starting from the current offset of the input contains a pattern.
    `boolean` | `contains(java.lang.String input, Pattern pattern)` Determines if a string contains a pattern.
    `MatchResult` | `getMatch()` Fetches the last match found by a call to a matches() or contains() method.
    `boolean` | `matches(char[] input, Pattern pattern)` Determines if a string (represented as a char[]) exactly matches a given pattern.
    `boolean` | `matches(PatternMatcherInput input, Pattern pattern)` Determines if the contents of a PatternMatcherInput instance exactly matches a given pattern.
    `boolean` | `matches(java.lang.String input, Pattern pattern)` Determines if a string exactly matches a given pattern.
    `boolean` | `matchesPrefix(char[] input, Pattern pattern)` Determines if a prefix of a string (represented as a char[]) matches a given pattern.
    `boolean` | `matchesPrefix(char[] input, Pattern pattern, int offset)` Determines if a prefix of a string (represented as a char[]) matches a given pattern, starting from a given offset into the string.
    `boolean` | `matchesPrefix(PatternMatcherInput input, Pattern pattern)` Determines if a prefix of a PatternMatcherInput instance matches a given pattern.
    `boolean` | `matchesPrefix(java.lang.String input, Pattern pattern)` Determines if a prefix of a string matches a given pattern.

- - ### Method Detail

    - #### matchesPrefix

          boolean matchesPrefix(char[] input,
                              Pattern pattern,
                              int offset)

      Determines if a prefix of a string (represented as a char[]) matches a given pattern, starting from a given offset into the string. If a prefix of the string matches the pattern, a MatchResult instance representing the match is made accesible via `getMatch()`.

      This method is useful for certain common token identification tasks that are made more difficult without this functionality.

      Parameters:
        `input` - The char[] to test for a prefix match.
        `pattern` - The Pattern to be matched.
        `offset` - The offset at which to start searching for the prefix.
      Returns:
        True if input matches pattern, false otherwise.

    - #### matchesPrefix

          boolean matchesPrefix(java.lang.String input,
                              Pattern pattern)

      Determines if a prefix of a string matches a given pattern. If a prefix of the string matches the pattern, a MatchResult instance representing the match is made accesible via `getMatch()`.

      This method is useful for certain common token identification tasks that are made more difficult without this functionality.

      Parameters:
        `input` - The String to test for a prefix match.
        `pattern` - The Pattern to be matched.
      Returns:
        True if input matches pattern, false otherwise.

    - #### matchesPrefix

          boolean matchesPrefix(char[] input,
                              Pattern pattern)

      Determines if a prefix of a string (represented as a char[]) matches a given pattern. If a prefix of the string matches the pattern, a MatchResult instance representing the match is made accesible via `getMatch()`.

      This method is useful for certain common token identification tasks that are made more difficult without this functionality.

      Parameters:
        `input` - The char[] to test for a prefix match.
        `pattern` - The Pattern to be matched.
      Returns:
        True if input matches pattern, false otherwise.

    - #### matchesPrefix

          boolean matchesPrefix(PatternMatcherInput input,
                              Pattern pattern)

      Determines if a prefix of a PatternMatcherInput instance matches a given pattern. If there is a match, a MatchResult instance representing the match is made accesible via `getMatch()`. Unlike the `contains(PatternMatcherInput, Pattern)` method, the current offset of the PatternMatcherInput argument is not updated. You should remember that the region starting from the begin offset of the PatternMatcherInput will be tested for a prefix match.

      This method is useful for certain common token identification tasks that are made more difficult without this functionality.

      Parameters:
        `input` - The PatternMatcherInput to test for a prefix match.
        `pattern` - The Pattern to be matched.
      Returns:
        True if input matches pattern, false otherwise.

    - #### matches

          boolean matches(java.lang.String input,
                        Pattern pattern)

      Determines if a string exactly matches a given pattern. If there is an exact match, a MatchResult instance representing the match is made accesible via `getMatch()`.

      Parameters:
        `input` - The String to test for an exact match.
        `pattern` - The Pattern to be matched.
      Returns:
        True if input matches pattern, false otherwise.

    - #### matches

          boolean matches(char[] input,
                        Pattern pattern)

      Determines if a string (represented as a char[]) exactly matches a given pattern. If there is an exact match, a MatchResult instance representing the match is made accesible via `getMatch()`.

      Parameters:
        `input` - The char[] to test for a match.
        `pattern` - The Pattern to be matched.
      Returns:
        True if input matches pattern, false otherwise.

    - #### matches

          boolean matches(PatternMatcherInput input,
                        Pattern pattern)

      Determines if the contents of a PatternMatcherInput instance exactly matches a given pattern. If there is an exact match, a MatchResult instance representing the match is made accesible via `getMatch()`. Unlike the `contains(PatternMatcherInput, Pattern)` method, the current offset of the PatternMatcherInput argument is not updated. You should remember that the region between the begin and end offsets of the PatternMatcherInput will be tested for an exact match.

      Parameters:
        `input` - The PatternMatcherInput to test for a match.
        `pattern` - The Pattern to be matched.
      Returns:
        True if input matches pattern, false otherwise.

    - #### contains

          boolean contains(java.lang.String input,
                         Pattern pattern)

      Determines if a string contains a pattern. If the pattern is matched by some substring of the input, a MatchResult instance representing the first such match is made acessible via `getMatch()`. If you want to access subsequent matches you should either use a PatternMatcherInput object or use the offset information in the MatchResult to create a substring representing the remaining input. Using the MatchResult offset information is the recommended method of obtaining the parts of the string preceeding the match and following the match.

      Parameters:
        `input` - The String to test for a match.
        `pattern` - The Pattern to be matched.
      Returns:
        True if the input contains a pattern match, false otherwise.

    - #### contains

          boolean contains(char[] input,
                         Pattern pattern)

      Determines if a string (represented as a char[]) contains a pattern. If the pattern is matched by some substring of the input, a MatchResult instance representing the first such match is made acessible via `getMatch()`. If you want to access subsequent matches you should either use a PatternMatcherInput object or use the offset information in the MatchResult to create a substring representing the remaining input. Using the MatchResult offset information is the recommended method of obtaining the parts of the string preceeding the match and following the match.

      Parameters:
        `input` - The String to test for a match.
        `pattern` - The Pattern to be matched.
      Returns:
        True if the input contains a pattern match, false otherwise.

    - #### contains

          boolean contains(PatternMatcherInput input,
                         Pattern pattern)

      Determines if the contents of a PatternMatcherInput, starting from the current offset of the input contains a pattern. If a pattern match is found, a MatchResult instance representing the first such match is made acessible via `getMatch()`. The current offset of the PatternMatcherInput is set to the offset corresponding to the end of the match, so that a subsequent call to this method will continue searching where the last call left off. You should remember that the region between the begin and end offsets of the PatternMatcherInput are considered the input to be searched, and that the current offset of the PatternMatcherInput reflects where a search will start from. Matches extending beyond the end offset of the PatternMatcherInput will not be matched. In other words, a match must occur entirely between the begin and end offsets of the input. See `PatternMatcherInput` for more details.

      This method is usually used in a loop as follows:

      >      PatternMatcher matcher;
      >      PatternCompiler compiler;
      >      Pattern pattern;
      >      PatternMatcherInput input;
      >      MatchResult result;

      >      compiler = new Perl5Compiler();
      >      matcher  = new Perl5Matcher();

      >      try {
      >        pattern = compiler.compile(somePatternString);
      >      } catch(MalformedPatternException e) {
      >        System.out.println("Bad pattern.");
      >        System.out.println(e.getMessage());
      >        return;
      >      }

      >      input   = new PatternMatcherInput(someStringInput);

      >      while(matcher.contains(input, pattern)) {
      >        result = matcher.getMatch();
      >        // Perform whatever processing on the result you want.
      >      }

      Parameters:
        `input` - The PatternMatcherInput to test for a match.
        `pattern` - The Pattern to be matched.
      Returns:
        True if the input contains a pattern match, false otherwise.

    - #### getMatch

          MatchResult getMatch()

      Fetches the last match found by a call to a matches() or contains() method.

      Returns:
        A MatchResult instance containing the pattern match found by the last call to any one of the matches() or contains() methods. If no match was found by the last call, returns null.

Copyright ? 2000-2003 Apache Software Foundation. All Rights Reserved.